#switch to use old composer frontend
%bcond_without composer
Name:           cockpit-image-builder
Version:        60
Release:        1.0.3%{?dist}
Summary:        Image builder plugin for Cockpit

License:        Apache-2.0
URL:            http://osbuild.org/
Source0:        https://github.com/osbuild/image-builder-frontend/releases/download/v%{version}/%{name}-%{version}.tar.gz
Source1:        composer-frontend.tar.gz

Obsoletes:      cockpit-composer < 54
Provides:       cockpit-composer = %{version}-%{release}

BuildArch:      noarch
BuildRequires:  gettext
BuildRequires:  libappstream-glib
BuildRequires:  make
BuildRequires:  nodejs

Requires:       cockpit
Requires:       cockpit-files
Requires:       osbuild-composer >= 131

%description
The image-builder-frontend generates custom images suitable for
deploying systems or uploading to the cloud. It integrates into Cockpit
as a frontend for osbuild.

%prep
%setup -q -n %{name}
%if %{with composer}
%setup -q -T -D -a1 -n %{name}
%{__mv} composer-frontend/LICENSE.txt ./
%{__mv} composer-frontend/README.md ./
%endif
declare -A replacements

replacements=(
    [#creating-a-blueprint_creating-blueprints-and-blueprint-images]=""
    [https://docs.redhat.com/en/documentation/red_hat_insights/1-latest/html/deploying_and_managing_rhel_systems_in_hybrid_clouds/index]="https://docs.oracle.com/en/operating-systems/oracle-linux/10/ibldr/AboutImageBuilder.html"
    [https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/8/html/configuring_basic_system_settings/assembly_using-secure-communications-between-two-systems-with-openssh_configuring-basic-system-settings#generating-ssh-key-pairs_assembly_using-secure-communications-between-two-systems-with-openssh]="https://docs.oracle.com/en/cloud/cloud-at-customer/occ-get-started/generate-ssh-key-pair.html"
    [https://docs.redhat.com/en/documentation/edge_management/2022/html/create_rhel_for_edge_images_and_configure_automated_management/index]="https://docs.oracle.com/en/operating-systems/oracle-linux/10/ibldr/AboutImageBuilder.html"
)

for rhel_url in access.redhat.com docs.redhat.com; do
  grep ${rhel_url} -rl --include='*.js' --include='*.json' --include '*.json.in' --include='*.jsx' --include='*.ts' --include='*.js.map' | while read filename; do
    for string in ${!replacements[@]}; do
        sed -i.bak "s|$string|${replacements[$string]}|g" $filename
        touch -r $filename.bak $filename
    done
  done

  for archive in $( find . -name '*.js.gz' -o -name '*.json.gz' -o -name '*.json.in.gz' -o -name '*.jsx.gz' -o -name '*.ts.gz' -o -name '*.js.map.gz' | xargs zgrep -l ${rhel_url} ); do
    for string in ${!replacements[@]}; do
        mv -v $archive ${archive}.bak
        zcat ${archive}.bak | sed "s|$string|${replacements[$string]}|g" > ${archive%.gz}
        gzip ${archive%.gz}
        touch -r ${archive}.bak ${archive}
    done
  done
done

%build
# Nothing to build

%install
%if %{with composer}
install -d %{buildroot}/%{_datadir}/cockpit/composer
%{__cp} -ar composer-frontend/* %{buildroot}/%{_datadir}/
%else
%make_install PREFIX=/usr
# drop source maps, they are large and just for debugging
find %{buildroot}%{_datadir}/cockpit/ -name '*.map' | xargs --no-run-if-empty rm --verbose
%endif

%if %{without composer}
%check
appstream-util validate-relax --nonet %{buildroot}/%{_datadir}/metainfo/*
%endif

%files
%doc README.md
%if %{with composer}
%license LICENSE.txt
%{_datadir}/cockpit/composer
%{_datadir}/metainfo/*
%else
%doc cockpit/README.md
%license LICENSE
%{_datadir}/cockpit/cockpit-image-builder
%{_datadir}/metainfo/*
%endif

%changelog
* Thu Jun 05 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 60-1.0.3
- Switch to old frotend [Orabug: 38011073] [Orabug: 37856296] [Orabug: 37856375]

* Fri May 09 2025 Akshata Konala <akshata.konala@oracle.com> - 60-1.0.2
- Replaced additional upstream url [Orabug: 37856187]

* Thu Apr 24 2025 Akshata Konala <akshata.konala@oracle.com> - 60-1.0.1
- Replaced upstream urls in documentation with oracle links [Orabug: 37856187]

* Wed Feb 12 2025 imagebuilder-bot <imagebuilder-bots+imagebuilder-bot@redhat.com> - 60-1
- New upstream release

* Fri Feb 07 2025 Sanne Raymaekers <sanne.raymaekers@gmail.com> - 59-1
- New upstream release


* Thu Jan 16 2025 Packit <hello@packit.dev> - v54-1
Initial commit on c10s
Resolves: RHELPLAN-171405

